/*

Metszet
1. Egy oktat nyilvntartja a hallgatinak a zh-n s a pt zh-n elrt
eredmnyeit. Adjuk meg azokat a hallgatkat, akik mindkt alkalommal
prblkoztak!

Uni
1. Egy oktat nyilvntartja a hallgatinak a zh-n s a pt zh-n elrt
eredmnyeit. Adjuk meg azokat a hallgatkat, akik legalbb az egyik
alkalommal prblkoztak

*/

#include <iostream>
#include <fstream>

using namespace std;

int main()
{
    cout << "Metszet es unio file-bol!" << endl;

    string inzhfilename="zh.dat";
    string inpotzhfilename="potzh.dat";
    string outmetszetfilename="mindketton.dat";
    string outuniofilename="egyikentuti.dat";

    ifstream inzhfile(inzhfilename.c_str(),ios::in);
    ifstream inpotzhfile(inpotzhfilename.c_str(),ios::in);
    ofstream outmetszetfile(outmetszetfilename.c_str(),ios::out);
    ofstream outuniofile(outuniofilename.c_str(),ios::out);

    if (!inzhfile){
        cout << "A file nem letezik! ("+inzhfilename+")";
        exit(1);
    }
    if (!inpotzhfile){
        cout << "A file nem letezik! ("+inpotzhfilename+")";
        exit(1);
    }
    const int MaxN=100;
    int n_zh;
    string zh[MaxN];
    int n_potzh;
    string potzh[MaxN];
    int n_metszet=0;
    string metszet[MaxN];
    int n_unio=0;
    string unio[2*MaxN];
    int j;

//beolvasas
    inzhfile >> n_zh;

    for (int i=0;i<n_zh;i++) {
        inzhfile >> zh[i];
    }

    inpotzhfile >> n_potzh;

    for (int i=0;i<n_potzh;i++) {
        inpotzhfile >> potzh[i];
    }

//metszet

    for (int i=0;i<n_zh;i++) {
        j=0;
        while ((j<n_potzh) && (zh[i]!=potzh[j])) {
            j++;
        }
        if (j<n_potzh) {
            metszet[n_metszet]=zh[i];
            n_metszet++;
        }
    }


//unio

    for (int i=0;i<n_zh;i++) {
        unio[n_unio]=zh[i];
        n_unio++;
    }
    for (int j=0;j<n_potzh;j++) {
        int i=0;
        while ((i<n_zh) && (zh[i]!=potzh[j])) {
            i++;
        }
        if (i>=n_zh) {
            unio[n_unio]=potzh[j];
            n_unio++;
        }
    }


//kiiras
    outmetszetfile << n_metszet << endl;

    for (int i=0;i<n_metszet;i++) {
        outmetszetfile << metszet[i] << endl;
    }

    outuniofile << n_unio << endl;

    for (int i=0;i<n_unio;i++) {
        outuniofile << unio[i] << endl;
    }


    inzhfile.close();
    inpotzhfile.close();
    outmetszetfile.close();
    outuniofile.close();

    return 0;
}
